;***************************************;
;****  SMALL FORTH RK-86, P_7_1995  ****;
;****  Reversed by Lavr 03.05.2020  ****;
;***************************************;

  ORG  0800H

  JMP  L081D            ;0800  C3 1D 08

  DB   0FFH             ;0803  FF
  DB   0FFH             ;0804  FF
  DB   0FFH             ;0805  FF

L0806:
;- 10     1040H
  JMP  LF803            ;0806  C3 03 F8
  JMP  LF809            ;0809  C3 09 F8
;-       0FB5H
  DB   0B5H             ;080C  B5
  DB   0FH              ;080D  0F
;-     1100H
  DB   00H              ;080E  00
  DB   11H              ;080F  11
;---------------------------------------------------
L0810:
  MVI  D,08H            ;0810  16 08
  NOP                   ;0812  00
  POP  B                ;0813  C1
  POP  D                ;0814  D1
  RET                   ;0815  C9

L0816:
;- , ,     
;-    LFA (Link Field Area).
  DW   L084F            ;0816  4F 08
;- ,   NFA - Name Field Area (+ -).
  DB   'COLD'           ;0818  43  C_
                        ;0819  4F  O_
                        ;081A  4C  L_
                        ;081B  44  D_
  DB   84H              ;081C  84  -
;-    -,    ASCII 
;-..    ,      63 
;-   -    IMMEDIAT;

;- NFA    (CFA - Code Field Area),   
;- ,    (:  )
L081D:
  LXI  B,L0806          ;081D  01 06 08
  LXI  H,L1040          ;0820  21 40 10
  MVI  E,0AH            ;0823  1E 0A
L0825:
  LDAX B                ;0825  0A
  MOV  M,A              ;0826  77
  INX  H                ;0827  23
  INX  B                ;0828  03
  DCR  E                ;0829  1D
  JNZ  L0825            ;082A  C2 25 08

  MVI  M,10H            ;082D  36 10
  INX  H                ;082F  23
  MVI  M,00H            ;0830  36 00

  LXI  SP,L1040         ;0832  31 40 10;  
  LXI  H,L107E          ;0835  21 7E 10;  
  CALL L0A06            ;0838  CD 06 0A
  RAR                   ;083B  1F
  RST  7                ;083C  FF
  CALL L0882            ;083D  CD 82 08
  LXI  B,L2100          ;0840  01 00 21
  CALL L0AD5            ;0843  CD D5 0A
L0846:
  CALL L0917            ;0846  CD 17 09
  JMP  L0A18            ;0849  C3 18 0A

  DB   0FFH             ;084C  FF
  DB   0FFH             ;084D  FF
  DB   0FFH             ;084E  FF

L084F:
  DW   L087C            ;084F  7C 08
  DB   'DROP'           ;0851  44  D
                        ;0852  52  R
                        ;0853  4F  O
                        ;0854  50  P
  DB   84H              ;0855  84  -
;-  (CFA - Code Field Area)
L0856:
  PUSH PSW              ;0856  F5
  MOV  C,M              ;0857  4E
  INX  H                ;0858  23
  MOV  B,M              ;0859  46
  INR  L                ;085A  2C
  JM   L0867            ;085B  FA 67 08
  POP  PSW              ;085E  F1
  RET                   ;085F  C9

L0860:
  POP  H                ;0860  E1
  CALL L0A06            ;0861  CD 06 0A
  LDAX B                ;0864  0A
  DCR  H                ;0865  25
  DB   0FFH             ;0866  FF

L0867:
  LXI  H,L107E          ;0867  21 7E 10
  POP  PSW              ;086A  F1
  CALL L0A06            ;086B  CD 06 0A
  DB   0AH              ;086E  0A
  DB   'stek'           ;086F  73  s
                        ;0870  74  t
                        ;0871  65  e
                        ;0872  6B  k
  DB   20H              ;0873  20
  DB   'pust'           ;0874  70  p
                        ;0875  75  u
                        ;0876  73  s
                        ;0877  74  t
  DB   0FFH             ;0878  FF
  JMP  L0BEA            ;0879  C3 EA 0B

L087C:
  DW   L0887            ;087C  87 08
  DB   'DUP'            ;087E  44  D
                        ;087F  55  U
                        ;0880  50  P
  DB   83H              ;0881  83   -
;-  (CFA - Code Field Area)
L0882:
  DCX  H                ;0882  2B
  MOV  M,B              ;0883  70
  DCX  H                ;0884  2B
  MOV  M,C              ;0885  71
  RET                   ;0886  C9

L0887:
  DW   L089C            ;0887  9C 08
  DB   'ROT'            ;0889  52  R
                        ;088A  4F  O
                        ;088B  54  T
  DB   83H              ;088C  83  -
;-  (CFA - Code Field Area)
L088D:
  MOV  E,M              ;088D  5E
  MOV  M,C              ;088E  71
  INX  H                ;088F  23
  MOV  D,M              ;0890  56
  MOV  M,B              ;0891  70
  INX  H                ;0892  23
  MOV  C,M              ;0893  4E
  MOV  M,E              ;0894  73
  INX  H                ;0895  23
  MOV  B,M              ;0896  46
  MOV  M,D              ;0897  72
  DCX  H                ;0898  2B
  DCX  H                ;0899  2B
  DCX  H                ;089A  2B
  RET                   ;089B  C9

L089C:
  DW   L08B4            ;089C  B4 08
  DB   '-ROT'           ;089E  2D  -
                        ;089F  52  R
                        ;08A0  4F  O
                        ;08A1  54  T
  DB   84H              ;08A2  84  -
;-  (CFA - Code Field Area)
  MOV  D,B              ;08A3  50
  MOV  E,C              ;08A4  59
  MOV  C,M              ;08A5  4E
  INX  H                ;08A6  23
  MOV  B,M              ;08A7  46
  INX  H                ;08A8  23
  MOV  A,M              ;08A9  7E
  MOV  M,E              ;08AA  73
  INX  H                ;08AB  23
  MOV  E,M              ;08AC  5E
  MOV  M,D              ;08AD  72
  DCX  H                ;08AE  2B
  DCX  H                ;08AF  2B
  MOV  M,E              ;08B0  73
  DCX  H                ;08B1  2B
  MOV  M,A              ;08B2  77
  RET                   ;08B3  C9

L08B4:
  DW   L08C7            ;08B4  C7  08
  DB   'OVER'           ;08B6  4F  O
                        ;08B7  56  V
                        ;08B8  45  E
                        ;08B9  52  R
  DB   84H              ;08A2  84  -
;-  (CFA - Code Field Area)
L08BB:
  CALL L0882            ;08BB  CD 82 08
  INX  H                ;08BE  23
  INX  H                ;08BF  23
  MOV  C,M              ;08C0  4E
  INX  H                ;08C1  23
  MOV  B,M              ;08C2  46
  DCX  H                ;08C3  2B
  DCX  H                ;08C4  2B
  DCX  H                ;08C5  2B
  RET                   ;08C6  C9

L08C7:
  DW   L08D7            ;08C7  D7 08
  DB   'SWAP'           ;08C9  53  S
                        ;08CA  57  W
                        ;08CB  41  A
                        ;08CC  50  P
  DB   84H              ;08A2  84  -
;-  (CFA - Code Field Area)
L08CE:
  MOV  A,M              ;08CE  7E
  MOV  M,C              ;08CF  71
  MOV  C,A              ;08D0  4F
  INX  H                ;08D1  23
  MOV  A,M              ;08D2  7E
  MOV  M,B              ;08D3  70
  MOV  B,A              ;08D4  47
  DCX  H                ;08D5  2B
  RET                   ;08D6  C9

L08D7:
  DW   L08E7            ;08D7  E7 08
  DB   'KEY'            ;08D9  4B  K
                        ;08DA  45  E
                        ;08DB  59  Y
  DB   83H              ;08DC  83  -
;-  (CFA - Code Field Area)
L08DD:
  CALL L0882            ;08DD  CD 82 08
  CALL L1040            ;08E0  CD 40 10
  MOV  C,A              ;08E3  4F
  MVI  B,00H            ;08E4  06 00
  RET                   ;08E6  C9

L08E7:
  DW   L090F            ;08E7  0F 09
  DB   'EMIT'           ;08E9  45  E
                        ;08EA  4D  M
                        ;08EB  49  I
                        ;08EC  54  T
  DB   84H              ;08A2  84  -
;-  (CFA - Code Field Area)
L08EE:
  MVI  A,0AH            ;08EE  3E 0A
  CMP  C                ;08F0  B9
  CZ   L0901            ;08F1  CC 01 09
  MVI  A,0DH            ;08F4  3E 0D
  CMP  C                ;08F6  B9
  CZ   L0909            ;08F7  CC 09 09
L08FA:
  CALL L1043            ;08FA  CD 43 10
  CALL L0856            ;08FD  CD 56 08
  RET                   ;0900  C9

L0901:
  CALL L0882            ;0901  CD 82 08
  MVI  C,0DH            ;0904  0E 0D
  JMP  L08FA            ;0906  C3 FA 08

L0909:
  CALL L0A06            ;0909  CD 06 0A
  LDAX B                ;090C  0A
  RST  7                ;090D  FF
  RET                   ;090E  C9

L090F:
  DW   L0976            ;090F  76 09
  DB   'WORDS'          ;0911  57  W
                        ;0912  4F  O
                        ;0913  52  R
                        ;0914  44  D
                        ;0915  53  S
  DB   85H              ;0916  85  -
;-  (CFA - Code Field Area)
L0917:
  CALL L0B6B            ;0917  CD 6B 0B
  CALL L0882            ;091A  CD 82 08
  LXI  B,L0810          ;091D  01 10 08
L0920:
  PUSH B                ;0920  C5
  CALL L0882            ;0921  CD 82 08
  LXI  B,L1048          ;0924  01 48 10
  CALL L0C0F            ;0927  CD 0F 0C
  CALL L0936            ;092A  CD 36 09
  POP  B                ;092D  C1
  ORA  A                ;092E  B7
  JZ   L094C            ;092F  CA 4C 09
  CALL L0856            ;0932  CD 56 08
  RET                   ;0935  C9

L0936:
  MOV  A,M              ;0936  7E
  INX  H                ;0937  23
  MOV  D,M              ;0938  56
  INX  H                ;0939  23
  CMP  C                ;093A  B9
  JNZ  L0948            ;093B  C2 48 09
  MOV  A,D              ;093E  7A
  CMP  B                ;093F  B8
  JNZ  L0948            ;0940  C2 48 09
  MVI  A,0FFH           ;0943  3E FF
  MOV  B,A              ;0945  47
  MOV  C,A              ;0946  4F
  RET                   ;0947  C9

L0948:
  XRA  A                ;0948  AF
  MOV  C,A              ;0949  4F
  MOV  B,A              ;094A  47
  RET                   ;094B  C9

L094C:
  CALL L0882            ;094C  CD 82 08
  INX  B                ;094F  03
  INX  B                ;0950  03
  MVI  A,04H            ;0951  3E 04
L0953:
  PUSH PSW              ;0953  F5
  CALL L0B60            ;0954  CD 60 0B
  POP  PSW              ;0957  F1
  DCR  A                ;0958  3D
  JNZ  L0953            ;0959  C2 53 09
  CALL L09F5            ;095C  CD F5 09
  LDAX B                ;095F  0A
  ORI  0F0H             ;0960  F6 F0
  ADI  04H              ;0962  C6 04
L0964:
  PUSH PSW              ;0964  F5
  CALL L0B60            ;0965  CD 60 0B
  POP  PSW              ;0968  F1
  INR  A                ;0969  3C
  JNZ  L0964            ;096A  C2 64 09
  CALL L0856            ;096D  CD 56 08
  CALL L0C0F            ;0970  CD 0F 0C
  JMP  L0920            ;0973  C3 20 09

L0976:
  DW   L09E0            ;0976  E0 09
  DB   27H              ;0978  27 _'_
  DB   81H              ;0979  81 -
;-  (CFA - Code Field Area)
L097A:
  CALL L0999            ;097A  CD 99 09
  CALL L0882            ;097D  CD 82 08
  LXI  B,L0810          ;0980  01 10 08
L0983:
  PUSH B                ;0983  C5
  CALL L0882            ;0984  CD 82 08
  LXI  B,L1048          ;0987  01 48 10
  CALL L0C0F            ;098A  CD 0F 0C
  CALL L0936            ;098D  CD 36 09
  POP  B                ;0990  C1
  ORA  A                ;0991  B7
  JZ   L09B0            ;0992  CA B0 09
  LXI  B,LFFFF          ;0995  01 FF FF
  RET                   ;0998  C9

L0999:
  XCHG                  ;0999  EB
  LHLD L104C            ;099A  2A 4C 10
L099D:
  MOV  A,M              ;099D  7E
  ORA  A                ;099E  B7
  JZ   L09A7            ;099F  CA A7 09
  CPI  21H              ;09A2  FE 21
  JM   L09AC            ;09A4  FA AC 09
L09A7:
  SHLD L104C            ;09A7  22 4C 10
  XCHG                  ;09AA  EB
  RET                   ;09AB  C9

L09AC:
  INX  H                ;09AC  23
  JMP  L099D            ;09AD  C3 9D 09

L09B0:
  PUSH H                ;09B0  E5
  LHLD L104C            ;09B1  2A 4C 10
  XCHG                  ;09B4  EB
  LXI  H,L0002          ;09B5  21 02 00
  DAD  B                ;09B8  09
L09B9:
  LDAX D                ;09B9  1A
  CMP  M                ;09BA  BE
  JNZ  L09C3            ;09BB  C2 C3 09
  INX  H                ;09BE  23
  INX  D                ;09BF  13
  JMP  L09B9            ;09C0  C3 B9 09

L09C3:
  CPI  21H              ;09C3  FE 21
  JM   L09CF            ;09C5  FA CF 09
L09C8:
  POP  H                ;09C8  E1
  CALL L0C0F            ;09C9  CD 0F 0C
  JMP  L0983            ;09CC  C3 83 09

L09CF:
  MOV  A,M              ;09CF  7E
  ORA  A                ;09D0  B7
  JM   L09D7            ;09D1  FA D7 09
  JMP  L09C8            ;09D4  C3 C8 09

L09D7:
  INX  H                ;09D7  23
  MOV  B,H              ;09D8  44
  MOV  C,L              ;09D9  4D
  XCHG                  ;09DA  EB
  SHLD L104C            ;09DB  22 4C 10
  POP  H                ;09DE  E1
  RET                   ;09DF  C9

L09E0:
  DW   L09EE            ;09E0  EE 09
  DB   'EXECUT'         ;09E2  45  E
                        ;09E3  58  X
                        ;09E4  45  E
                        ;09E5  43  C
                        ;09E6  55  U
                        ;09E7  54  T
  DB   86H              ;09E8  86  -
;-  (CFA - Code Field Area)
L09E9:
  PUSH B                ;09E9  C5
  CALL L0856            ;09EA  CD 56 08
  RET                   ;09ED  C9

L09EE:
  DW   L0A11            ;09EE  11 0A
  DB   'TYPE'           ;09F1  54  T
                        ;09F1  59  Y
                        ;09F2  50  P
                        ;09F3  45  E
  DB   84H              ;09F4  84  -
;-  (CFA - Code Field Area)
L09F5:
  CALL L0882            ;09F5  CD 82 08
  CALL L0C1B            ;09F8  CD 1B 0C
  CALL L08EE            ;09FB  CD EE 08
  INX  B                ;09FE  03
  LDAX B                ;09FF  0A
  ORA  A                ;0A00  B7
  RM                    ;0A01  F8
  RZ                    ;0A02  C8
  JMP  L09F5            ;0A03  C3 F5 09

L0A06:
  CALL L0882            ;0A06  CD 82 08
  POP  B                ;0A09  C1
  CALL L09F5            ;0A0A  CD F5 09
  INX  B                ;0A0D  03
  JMP  L09E9            ;0A0E  C3 E9 09

L0A11:
  DW   L0A3A            ;0A11  3A 0A
  DB   'QUIT'           ;0A13  51  Q
                        ;0A14  55  U
                        ;0A15  49  I
                        ;0A16  54  T
  DB   84H              ;0A17  84  -
;-  (CFA - Code Field Area)
L0A18:
  XRA  A                ;0A18  AF
  STA  L104B            ;0A19  32 4B 10
L0A1C:
  LXI  SP,L1040         ;0A1C  31 40 10
  CALL L0A06            ;0A1F  CD 06 0A
  LDAX B                ;0A22  0A
  MVI  A,0FFH           ;0A23  3E FF
  CALL L0882            ;0A25  CD 82 08
  LXI  B,L1080          ;0A28  01 80 10
  CALL L0A42            ;0A2B  CD 42 0A
  CALL L0882            ;0A2E  CD 82 08
  LXI  B,L1080          ;0A31  01 80 10
  CALL L0AD5            ;0A34  CD D5 0A
  JMP  L0A1C            ;0A37  C3 1C 0A

L0A3A:
  DW   L0AC9            ;0A3A  C9 0A
  DB   'QUERY'          ;0A3C  51  Q
                        ;0A3D  55  U
                        ;0A3E  45  E
                        ;0A3F  52  R
                        ;0A40  59  Y
  DB   85H              ;0A41  85  -
;-  (CFA - Code Field Area)
L0A42:
  DCX  B                ;0A42  0B
  PUSH B                ;0A43  C5
  XTHL                  ;0A44  E3
  SHLD L104E            ;0A45  22 4E 10
  POP  H                ;0A48  E1
  CALL L0856            ;0A49  CD 56 08
L0A4C:
  CALL L08DD            ;0A4C  CD DD 08
  MVI  A,03H            ;0A4F  3E 03
  CMP  C                ;0A51  B9
  JNZ  L0A5B            ;0A52  C2 5B 0A
  CALL L0856            ;0A55  CD 56 08
  CALL LF800            ;0A58  CD 00 F8  <F4> -> F800H (MONITOR)
L0A5B:
  CALL L0882            ;0A5B  CD 82 08
  CALL L0882            ;0A5E  CD 82 08
  CALL L08EE            ;0A61  CD EE 08
  CALL L0A71            ;0A64  CD 71 0A
  MOV  A,C              ;0A67  79
  CALL L0856            ;0A68  CD 56 08
  CPI  0DH              ;0A6B  FE 0D
  JNZ  L0A4C            ;0A6D  C2 4C 0A
  RET                   ;0A70  C9

L0A71:
  MVI  A,0DH            ;0A71  3E 0D
  CMP  C                ;0A73  B9
  JNZ  L0A87            ;0A74  C2 87 0A
  CALL L0882            ;0A77  CD 82 08
  MVI  C,20H            ;0A7A  0E 20
  CALL L0A87            ;0A7C  CD 87 0A
  MVI  C,00H            ;0A7F  0E 00
  CALL L0882            ;0A81  CD 82 08
  CALL L0A87            ;0A84  CD 87 0A
L0A87:
  XCHG                  ;0A87  EB
  LHLD L104E            ;0A88  2A 4E 10
  INX  H                ;0A8B  23
  MVI  A,08H            ;0A8C  3E 08
  CMP  C                ;0A8E  B9
  CZ   L0AA1            ;0A8F  CC A1 0A
  MVI  A,18H            ;0A92  3E 18
  CMP  C                ;0A94  B9
  CZ   L0AB9            ;0A95  CC B9 0A
  MOV  M,C              ;0A98  71
  SHLD L104E            ;0A99  22 4E 10
  XCHG                  ;0A9C  EB
  CALL L0856            ;0A9D  CD 56 08
  RET                   ;0AA0  C9

L0AA1:
  DCX  H                ;0AA1  2B
  DCX  H                ;0AA2  2B
  XCHG                  ;0AA3  EB
  PUSH H                ;0AA4  E5
  CALL L0882            ;0AA5  CD 82 08
  INX  D                ;0AA8  13
  LDAX D                ;0AA9  1A
  DCX  D                ;0AAA  1B
  MOV  C,A              ;0AAB  4F
  CALL L08EE            ;0AAC  CD EE 08
  CALL L0882            ;0AAF  CD 82 08
  CALL L08EE            ;0AB2  CD EE 08
  POP  H                ;0AB5  E1
  XCHG                  ;0AB6  EB
  MOV  C,M              ;0AB7  4E
  RET                   ;0AB8  C9

;-----***
L0AB9:
  XCHG                  ;0AB9  EB
  CALL L0A06            ;0ABA  CD 06 0A
  DB   08H              ;0ABD  08
  DB   0FFH             ;0ABE  FF
  LDAX D                ;0ABF  1A
  MOV  C,A              ;0AC0  4F
  CALL L0882            ;0AC1  CD 82 08
  CALL L08EE            ;0AC4  CD EE 08
  XCHG                  ;0AC7  EB
  RET                   ;0AC8  C9

L0AC9:
  DW   L0B58            ;0AC9  58 0B
  DB   'INTERPRET'      ;0ACB  49  I
                        ;0ACC  4E  N
                        ;0ACD  54  T
                        ;0ACE  45  E
                        ;0ACF  52  R
                        ;0AD0  50  P
                        ;0AD1  52  R
                        ;0AD2  45  E
                        ;0AD3  54  T
  DB   89H              ;0AD4  89  -
;-  (CFA - Code Field Area)
L0AD5:
  PUSH B                ;0AD5  C5
  XTHL                  ;0AD6  E3
  SHLD L104C            ;0AD7  22 4C 10
  POP  H                ;0ADA  E1
  CALL L0856            ;0ADB  CD 56 08
L0ADE:
  CALL L0B1C            ;0ADE  CD 1C 0B
  CALL L097A            ;0AE1  CD 7A 09
  MVI  A,0FFH           ;0AE4  3E FF
  CMP  C                ;0AE6  B9
  JNZ  L0B09            ;0AE7  C2 09 0B
  CMP  B                ;0AEA  B8
  JNZ  L0B09            ;0AEB  C2 09 0B
  CALL L0856            ;0AEE  CD 56 08
  CALL L0B9C            ;0AF1  CD 9C 0B
  LDA  L104B            ;0AF4  3A 4B 10
  ORA  A                ;0AF7  B7
  CNZ  L0B3C            ;0AF8  C4
  JMP  L0ADE            ;0AFB  C3 DE 0A

L0AFE:
  DCX  B                ;0AFE  0B
  LDAX B                ;0AFF  0A
  INX  B                ;0B00  03
  ANI  40H              ;0B01  E6 40
  JZ   L0B29            ;0B03  CA 29 0B
  JMP  L09E9            ;0B06  C3 E9 09

L0B09:
  LDA  L104B            ;0B09  3A 4B 10
  ORA  A                ;0B0C  B7
  JZ   L0B16            ;0B0D  CA 16 0B
  CALL L0AFE            ;0B10  CD FE 0A
  JMP  L0ADE            ;0B13  C3 DE 0A

L0B16:
  CALL L09E9            ;0B16  CD E9 09
  JMP  L0ADE            ;0B19  C3 DE 0A

L0B1C:
  PUSH H                ;0B1C  E5
  LHLD L1048            ;0B1D  2A 48 10
L0B20:
  XCHG                  ;0B20  EB
  LHLD L1046            ;0B21  2A 46 10
  MOV  M,E              ;0B24  73
  INX  H                ;0B25  23
  MOV  M,D              ;0B26  72
  POP  H                ;0B27  E1
  RET                   ;0B28  C9

L0B29:
  PUSH H                ;0B29  E5
  LHLD L1048            ;0B2A  2A 48 10
  MVI  M,0CDH           ;0B2D  36 CD
  INX  H                ;0B2F  23
  MOV  M,C              ;0B30  71
  INX  H                ;0B31  23
  MOV  M,B              ;0B32  70
  INX  H                ;0B33  23
  SHLD L1048            ;0B34  22 48 10
  POP  H                ;0B37  E1
  CALL L0856            ;0B38  CD 56 08
  RET                   ;0B3B  C9

L0B3C:
  CALL L0882            ;0B3C  CD 82 08
  LXI  B,L0882          ;0B3F  01 82 08
  CALL L0B29            ;0B42  CD 29 0B
  PUSH H                ;0B45  E5
  LHLD L1048            ;0B46  2A 48 10
  MVI  M,01H            ;0B49  36 01
  INX  H                ;0B4B  23
  MOV  M,C              ;0B4C  71
  INX  H                ;0B4D  23
  MOV  M,B              ;0B4E  70
  INX  H                ;0B4F  23
  SHLD L1048            ;0B50  22 48 10
  POP  H                ;0B53  E1
  CALL L0856            ;0B54  CD 56 08
  RET                   ;0B57  C9

L0B58:
  DW   L0B66            ;0B58  66 0B
  DB   'SPACE'          ;0B5A  53  S
                        ;0B5B  50  P
                        ;0B5C  41  A
                        ;0B5D  43  C
                        ;0B5E  45  E
  DB   85H              ;0B5F  85  -
;-  (CFA - Code Field Area)
L0B60:
  CALL L0A06            ;0B60  CD 06 0A
  DB   20H              ;0B63  20
  DB   0FFH             ;0B64  FF
  RET                   ;0B65  C9

L0B66:
  DW   L0B71            ;0B66  71 0B
  DB   'CR'             ;0B68  43  C
                        ;0B69  52  R
  DB   82H              ;0B6A  82  -
;-  (CFA - Code Field Area)
L0B6B:
  CALL L0A06            ;0B6B  CD 06 0A
  DB   0AH              ;0B6E  0A
  DB   0FFH             ;0B6F  FF
  RET                   ;0B70  C9

L0B71:
  DW   L0B82            ;0B71  82 0B
  DB   'HERE'           ;0B73  48  H
                        ;0B74  45  E
                        ;0B75  52  R
                        ;0B76  45  E
  DB   84H              ;0B77  84  -
;-  (CFA - Code Field Area)
L0B78:
  CALL L0882            ;0B78  CD 82 08
  PUSH H                ;0B7B  E5
  LHLD L1048            ;0B7C  2A 48 10
  XTHL                  ;0B7F  E3
  POP  B                ;0B80  C1
  RET                   ;0B81  C9

L0B82:
  DW   L0B93            ;0B82  93 0B
  DB   'NEGATE'         ;0B84  4E  N
                        ;0B85  45  E
                        ;0B86  47  G
                        ;0B87  41  A
                        ;0B88  54  T
                        ;0B89  45  E
  DB   86H              ;0B8A  86  -
;-  (CFA - Code Field Area)
L0B8B:
  MOV  A,C              ;0B8B  79
  CMA                   ;0B8C  2F
  MOV  C,A              ;0B8D  4F
  MOV  A,B              ;0B8E  78
  CMA                   ;0B8F  2F
  MOV  B,A              ;0B90  47
  INX  B                ;0B91  03
  RET                   ;0B92  C9

L0B93:
  DW   L0C0B            ;0B93  0B 0C
  DB   'NUMBER'         ;0B95  4E  N
                        ;0B96  55  U
                        ;0B97  4D  M
                        ;0B98  42  B
                        ;0B99  45  E
                        ;0B9A  52  R
  DB   86H              ;0B9B  86  -
;-  (CFA - Code Field Area)
L0B9C:
  CALL L0882            ;0B9C  CD 82 08
  CALL L0999            ;0B9F  CD 99 09
  LDAX D                ;0BA2  1A
  CPI  2DH              ;0BA3  FE 2D '-'
  JNZ  L0BB0            ;0BA5  C2 B0 0B
  CZ   L0BAF            ;0BA8  CC AF 0B
  CALL L0B8B            ;0BAB  CD 8B 0B
  RET                   ;0BAE  C9

L0BAF:
  INX  D                ;0BAF  13
L0BB0:
  PUSH H                ;0BB0  E5
  LXI  H,L0000          ;0BB1  21 00 00
L0BB4:
  LDAX D                ;0BB4  1A
  CPI  21H              ;0BB5  FE 21 _!_
  JM   L0C02            ;0BB7  FA 02 0C
  CPI  30H              ;0BBA  FE 30 '0'
  JM   L0BEA            ;0BBC  FA EA 0B
  CPI  3AH              ;0BBF  FE 3A ':'>9
  JP   L0BDB            ;0BC1  F2 DB 0B
L0BC4:
  ANI  0FH              ;0BC4  E6 0F
  MVI  B,00H            ;0BC6  06 00
  MOV  C,A              ;0BC8  4F
  PUSH B                ;0BC9  C5
  PUSH H                ;0BCA  E5
  POP  B                ;0BCB  C1
  LDA  L104A            ;0BCC  3A 4A 10
  DCR  A                ;0BCF  3D
L0BD0:
  DAD  B                ;0BD0  09
  DCR  A                ;0BD1  3D
  JNZ  L0BD0            ;0BD2  C2 D0 0B
  POP  B                ;0BD5  C1
  DAD  B                ;0BD6  09
  INX  D                ;0BD7  13
  JMP  L0BB4            ;0BD8  C3 B4 0B

L0BDB:
  CPI  41H              ;0BDB  FE 41 'A'
  JM   L0BEA            ;0BDD  FA EA 0B
  CPI  47H              ;0BE0  FE 47 'G'>'F'
  JP   L0BEA            ;0BE2  F2 EA 0B
  ADI  0C9H             ;0BE5  C6 C9
  JMP  L0BC4            ;0BE7  C3 C4 0B

L0BEA:
  LXI  SP,L1040         ;0BEA  31 40 10
  LXI  H,L107E          ;0BED  21 7E 10
  CALL L0A06            ;0BF0  CD 06 0A
  LDAX B                ;0BF3  0A
  CMC                   ;0BF4  3F
  RST  7                ;0BF5  FF ? ***
  PUSH H                ;0BF6  E5
  LHLD L104C            ;0BF7  2A 4C 10
  XTHL                  ;0BFA  E3
  POP  B                ;0BFB  C1
  CALL L09F5            ;0BFC  CD F5 09
  JMP  L0846            ;0BFF  C3 46 08

L0C02:
  INX  D                ;0C02  13
  XCHG                  ;0C03  EB
  SHLD L104C            ;0C04  22 4C 10
  POP  H                ;0C07  E1
  MOV  B,D              ;0C08  42
  MOV  C,E              ;0C09  4B
  RET                   ;0C0A  C9

L0C0B:
  DW   L0C16            ;0C0B  16 0C
  DB   '@'              ;0C0D  40  @
  DB   81H              ;0C0E  81  -
;-  (CFA - Code Field Area)
L0C0F:
  LDAX B                ;0C0F  0A
  MOV  E,A              ;0C10  5F  _
  INX  B                ;0C11  03
  LDAX B                ;0C12  0A
  MOV  B,A              ;0C13  47
  MOV  C,E              ;0C14  4B
  RET                   ;0C15  C9

L0C16:
  DW   L0C20            ;0C16  20 0C
  DB   'C@'             ;0C18  43  C
                        ;0C19  40  @
  DB   82H              ;0C1A  82  -
;-  (CFA - Code Field Area)
L0C1B:
  LDAX B                ;0C1B  0A
  MOV  C,A              ;0C1C  4F
  MVI  B,00H            ;0C1D  06 00
  RET                   ;0C1F  C9

L0C20:
  DW   L0C2F            ;0C20  2F 0C
  DB   21H              ;0C22  21 '!'
  DB   81H              ;0C23  81  -
;-  (CFA - Code Field Area)
L0C24:
  MOV  A,M              ;0C24  7E
  STAX B                ;0C25  02
  INX  H                ;0C26  23
  INX  B                ;0C27  03
  MOV  A,M              ;0C28  7E
  STAX B                ;0C29  02
  INX  H                ;0C2A  23
  CALL L0856            ;0C2B  CD 56 08
  RET                   ;0C2E  C9

L0C2F:
  DW   L0C3C            ;0C2F  3C 0C
  DB   'C!'             ;0C31  43  C
                        ;0C32  21
  DB   82H              ;0C33  82  -
;-  (CFA - Code Field Area)
  MOV  A,M              ;0C34  7E
  INX  H                ;0C35  23
  INX  H                ;0C36  23
  STAX B                ;0C37  02
  CALL L0856            ;0C38  CD 56 08
  RET                   ;0C3B  C9

L0C3C:
  DW   L0C4C            ;0C3C  4C 0C
  DB   '-'              ;0C3E  2D '-'
  DB   81H              ;0C3F  81  -
;-  (CFA - Code Field Area)
L0C40:
  MOV  A,M              ;0C40  7E
  SUB  C                ;0C41  91
  MOV  M,A              ;0C42  77
  INX  H                ;0C43  23
  MOV  A,M              ;0C44  7E
  SBB  B                ;0C45  98
  MOV  M,A              ;0C46  77
  DCX  H                ;0C47  2B
  CALL L0856            ;0C48  CD 56 08
  RET                   ;0C4B  C9

L0C4C:
  DW   L0C59            ;0C4C  59 0C
  DB   '+'              ;0C4E  2B '+'
  DB   81H              ;0C4F  81  -
;-  (CFA - Code Field Area)
  MOV  A,M              ;0C50  7E
  INX  H                ;0C51  23
  ADD  C                ;0C52  81
  MOV  C,A              ;0C53  4F
  MOV  A,M              ;0C54  7E
  INX  H                ;0C55  23
  ADC  B                ;0C56  88
  MOV  B,A              ;0C57  47
  RET                   ;0C58  C9

L0C59:
  DW   L0C66            ;0C59  66 0C
  DB   '2*'             ;0C5B  32 2A
  DB   82H              ;0C5D  82  -
;-  (CFA - Code Field Area)
L0C5E:
  XRA  A                ;0C5E  AF
  MOV  A,C              ;0C5F  79
  RAL                   ;0C60  17
  MOV  C,A              ;0C61  4F
  MOV  A,B              ;0C62  78
  RAL                   ;0C63  17
  MOV  B,A              ;0C64  47
  RET                   ;0C65  C9

L0C66:
  DW   L0C73            ;0C66  73 0C
  DB   '2/'             ;0C68  32 2F
  DB   82H              ;0C6A  82  -
;-  (CFA - Code Field Area)
  XRA  A                ;0C6B  AF
  MOV  A,B              ;0C6C  78
  RAR                   ;0C6D  1F
  MOV  B,A              ;0C6E  47
  MOV  A,C              ;0C6F  79
  RAR                   ;0C70  1F
  MOV  C,A              ;0C71  4F
  RET                   ;0C72  C9

L0C73:
  DW   L0C89            ;0C73  89 0C
  DB   '<'              ;0C75  3C  <
  DB   81H              ;0C76  81  -
;-  (CFA - Code Field Area)
L0C77:
  CALL L0C40            ;0C77  CD 40 0C
  MOV  A,B              ;0C7A  78
  ANI  80H              ;0C7B  E6 80
  JM   L0C84            ;0C7D  FA 84 0C
  XRA  A                ;0C80  AF
  MOV  C,A              ;0C81  4F
  MOV  B,A              ;0C82  47
  RET                   ;0C83  C9

L0C84:
  MVI  A,0FFH           ;0C84  3E FF
  MOV  C,A              ;0C86  4F
  MOV  B,A              ;0C87  47
  RET                   ;0C88  C9

L0C89:
  DW   L0C93            ;0C89  93 0C
  DB   '>'              ;0C8B  3E >
  DB   81H              ;0C8C  81 -
;-  (CFA - Code Field Area)
  CALL L08CE            ;0C8D  CD CE 08
  JMP  L0C77            ;0C90  C3 77 0C

L0C93:
  DW   L0C9A            ;0C93  9A 0C
  DB   '='              ;0C95  3D
  DB   81H              ;0C96  81  -
;-  (CFA - Code Field Area)
  JMP  L0936            ;0C97  C3 36 09

L0C9A:
  DW   L0CAD            ;0C9A  AD 0C
  DB   '0='             ;0C9C  30  0
                        ;0C9D  3D  =
  DB   82H              ;0C9E  82  -
;-  (CFA - Code Field Area)
L0C9F:
  XRA  A                ;0C9F  AF
  CMP  C                ;0CA0  B9
  JNZ  L0CAA            ;0CA1  C2 AA 0C
  CMP  B                ;0CA4  B8
  JNZ  L0CAA            ;0CA5  C2 AA 0C
  DCX  B                ;0CA8  0B
  RET                   ;0CA9  C9

L0CAA:
  MOV  C,A              ;0CAA  4F
  MOV  B,A              ;0CAB  47
  RET                   ;0CAC  C9

L0CAD:
  DW   L0CC0            ;0CAD  C0 0C
  DB   '0<'             ;0CAF  30  0
                        ;0CB0  3C  <
  DB   82H              ;0CB1  82  -
;-  (CFA - Code Field Area)
  MVI  A,80H            ;0CB2  3E 80
  ANA  B                ;0CB4  A0
  JZ   L0CBC            ;0CB5  CA BC 0C
  LXI  B,LFFFF          ;0CB8  01 FF FF
  RET                   ;0CBB  C9

L0CBC:
  LXI  B,L0000          ;0CBC  01 00 00
  RET                   ;0CBF  C9

L0CC0:
  DW   L0CD3            ;0CC0  D3 0C
  DB   '0>'             ;0CC2  30 3E >
  DB   82H              ;0CC4  82 -
;-  (CFA - Code Field Area)
  MVI  A,80H            ;0CC5  3E 80
  ANA  B                ;0CC7  A0
  JNZ  L0CBC            ;0CC8  C2 BC 0C
  LXI  B,LFFFF          ;0CCB  01 FF FF
  RET                   ;0CCE  C9

  LXI  B,L0000          ;0CCF  01 00 00
  RET                   ;0CD2  C9

L0CD3:
  DW   L0CE2            ;0CD3  E2 0C
  DB   'AND'            ;0CD6  41  A
                        ;0CD6  4E  N
                        ;0CD7  44  D
  DB   83H              ;0CD8  83  -
;-  (CFA - Code Field Area)
  MOV  A,M              ;0CD9  7E
  ANA  C                ;0CDA  A1
  MOV  C,A              ;0CDB  4F
  INX  H                ;0CDC  23
  MOV  A,M              ;0CDD  7E
  ANA  B                ;0CDE  A0
  MOV  B,A              ;0CDF  47
  INX  H                ;0CE0  23
  RET                   ;0CE1  C9

L0CE2:
  DW   L0CF0            ;0CE2  F0 0C
  DB   'OR'             ;0CE4  4F  O
                        ;0CE5  52  R
  DB   82H              ;0CE6  82  -
;-  (CFA - Code Field Area)
  MOV  A,M              ;0CE7  7E
  ORA  C                ;0CE8  B1
  MOV  C,A              ;0CE9  4F
  INX  H                ;0CEA  23
  MOV  A,M              ;0CEB  7E
  ORA  B                ;0CEC  B0
  MOV  B,A              ;0CED  47
  INX  H                ;0CEE  23
  RET                   ;0CEF  C9

L0CF0:
  DW   L0D04            ;0CF0  04 0D
  DB   2CH              ;0CF2  2C _,_
  DB   81H              ;0CF3  81  -
;-  (CFA - Code Field Area)
L0CF4:
  XCHG                  ;0CF4  EB
  LHLD L1048            ;0CF5  2A 48 10
  MOV  M,C              ;0CF8  71
  INX  H                ;0CF9  23
  MOV  M,B              ;0CFA  70
  INX  H                ;0CFB  23
  SHLD L1048            ;0CFC  22 48 10
  XCHG                  ;0CFF  EB
  CALL L0856            ;0D00  CD 56 08
  RET                   ;0D03  C9

L0D04:
  DW   L0D17            ;0D04  17 0D
  DB   'C'              ;0D06  43  C
  DB   2CH              ;0D07  2C _,_
  DB   82H              ;0D08  82  -
;-  (CFA - Code Field Area)
L0D09:
  XCHG                  ;0D09  EB
  LHLD L1048            ;0D0A  2A 48 10
  MOV  M,C              ;0D0D  71
  INX  H                ;0D0E  23
  SHLD L1048            ;0D0F  22 48 10
  XCHG                  ;0D12  EB
  CALL L0856            ;0D13  CD 56 08
  RET                   ;0D16  C9

L0D17:
  DW   L0D26            ;0D17  26 0D
  DB   'XOR'            ;0D19  58  X
                        ;0D1A  4F  O
                        ;0D1B  52  R
  DB   83H              ;0D1C  83  -
;-  (CFA - Code Field Area)
  MOV  A,M              ;0D1D  7E
  INX  H                ;0D1E  23
  XRA  C                ;0D1F  A9
  MOV  C,A              ;0D20  4F
  MOV  A,M              ;0D21  7E
  INX  H                ;0D22  23
  XRA  B                ;0D23  A8
  MOV  B,A              ;0D24  47
  RET                   ;0D25  C9

L0D26:
  DW   L0D51            ;0D26  51 0D
  DB   'IF'             ;0D28  49  I
                        ;0D29  46  F
  DB   0C2H             ;0D2A  C2  - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0882            ;0D2B  CD 82 08
  LXI  B,L0D48          ;0D2E  01 48 0D
  CALL L0B29            ;0D31  CD 29 0B
L0D34:
  CALL L0882            ;0D34  CD 82 08
  MVI  C,0C2H           ;0D37  0E C2
  CALL L0D09            ;0D39  CD 09 0D
  CALL L0B78            ;0D3C  CD 78 0B
  CALL L0882            ;0D3F  CD 82 08
  INX  B                ;0D42  03
  INX  B                ;0D43  03
  CALL L0CF4            ;0D44  CD F4 0C
  RET                   ;0D47  C9

L0D48:
  CALL L0C9F            ;0D48  CD 9F 0C
  MOV  A,C              ;0D4B  79
  CALL L0856            ;0D4C  CD 56 08
  ORA  A                ;0D4F  B7
  RET                   ;0D50  C9

L0D51:
  DW   L0D75            ;0D51  75 0D
  DB   'ELSE'           ;0D53  45  E
                        ;0D54  4C  L
                        ;0D55  53  S
                        ;0D56  45  E
  DB   0C4H             ;0D57  C4  - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0882            ;0D58  CD 82 08
  MVI  C,0C3H           ;0D5B  0E C3
  CALL L0D09            ;0D5D  CD 09 0D
  CALL L0B78            ;0D60  CD 78 0B
  CALL L0882            ;0D63  CD 82 08
  INX  B                ;0D66  03
  INX  B                ;0D67  03
  CALL L0CF4            ;0D68  CD F4 0C
  CALL L0B78            ;0D6B  CD 78 0B
  CALL L088D            ;0D6E  CD 8D 08
  CALL L0C24            ;0D71  CD 24 0C
  RET                   ;0D74  C9

L0D75:
  DW   L0D86            ;0D75  86 0D
  DB   'THEN'           ;0D77  54  T
                        ;0D78  48  H
                        ;0D79  45  E
                        ;0D7A  4E  N
  DB   0C4H             ;0D7B  C4  - IMMEDIAT,
;-  (CFA - Code Field Area)
L0D7C:
  CALL L0B78            ;0D7C  CD 78 0B
  CALL L08CE            ;0D7F  CD CE 08
  CALL L0C24            ;0D82  CD 24 0C
  RET                   ;0D85  C9

L0D86:
  DW   L0D91            ;0D86  91 0D
  DB   'BEGIN'          ;0D88  42  B
                        ;0D89  45  E
                        ;0D8A  47  G
                        ;0D8B  49  I
                        ;0D8C  4E  N
  DB   0C5H             ;0D8D  C5  - IMMEDIAT,
;-  (CFA - Code Field Area)
  JMP  L0B78            ;0D8E  C3 78 0B

L0D91:
  DW   L0DAB            ;0D91  AB 0D
  DB   'REPEAT'         ;0D93  52  R
                        ;0D94  45  E
                        ;0D95  50  P
                        ;0D96  45  E
                        ;0D97  41  A
                        ;0D98  54  T
  DB   0C6H             ;0D99  C6  - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0882            ;0D9A  CD 82 08
  MVI  C,0C3H           ;0D9D  0E C3
  CALL L0D09            ;0D9F  CD 09 0D
  CALL L08CE            ;0DA2  CD CE 08
  CALL L0CF4            ;0DA5  CD F4 0C
  JMP  L0D7C            ;0DA8  C3 7C 0D

L0DAB:
  DW   L0E06            ;0DAB  06 0E
  DB   '+DO'            ;0DAD  2B
                        ;0DAE  44  D
                        ;0DAF  4F  O
  DB   0C3H             ;0DB0  C3  - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0882            ;0DB3  CD 82 08
  LXI  B,L0DC9          ;0DB4  01 C9 0D
  CALL L0B29            ;0DB7  CD 29 0B
  CALL L0B78            ;0DBA  CD 78 0B
  CALL L0882            ;0DBD  CD 82 08
  LXI  B,L0DD8          ;0DC0  01 D8 0D
  CALL L0B29            ;0DC3  CD 29 0B
  JMP  L0D34            ;0DC6  C3 34 0D

L0DC9:
  POP  D                ;0DC9  D1
  PUSH B                ;0DCA  C5
  CALL L0C40            ;0DCB  CD 40 0C
L0DCE:
  PUSH B                ;0DCE  C5
  CALL L0856            ;0DCF  CD 56 08
  PUSH B                ;0DD2  C5
  CALL L0856            ;0DD3  CD 56 08
  PUSH D                ;0DD6  D5
  RET                   ;0DD7  C9

L0DD8:
  POP  D                ;0DD8  D1
  CALL L0882            ;0DD9  CD 82 08
  POP  B                ;0DDC  C1
  CALL L0882            ;0DDD  CD 82 08
  POP  B                ;0DE0  C1
  PUSH D                ;0DE1  D5
  CALL L08BB            ;0DE2  CD BB 08
  CALL L08BB            ;0DE5  CD BB 08
  CALL L0936            ;0DE8  CD 36 09
  CALL L0856            ;0DEB  CD 56 08
  ORA  A                ;0DEE  B7
  JNZ  L0DFD            ;0DEF  C2 FD 0D
  POP  D                ;0DF2  D1
  XTHL                  ;0DF3  E3
  PUSH H                ;0DF4  E5
  DAD  B                ;0DF5  09
  MOV  B,H              ;0DF6  44
  MOV  C,L              ;0DF7  4D
  POP  H                ;0DF8  E1
  XTHL                  ;0DF9  E3
  JMP  L0DCE            ;0DFA  C3 CE 0D

L0DFD:
  POP  B                ;0DFD  C1
  POP  D                ;0DFE  D1
  PUSH B                ;0DFF  C5
  INX  H                ;0E00  23
  INX  H                ;0E01  23
  CALL L0856            ;0E02  CD 56 08
  RET                   ;0E05  C9

L0E06:
  DW   L0E17            ;0E06  17 0E
  DB   'I'              ;0E08  49 I
  DB   81H              ;0E09  81  -
;-  (CFA - Code Field Area)
  CALL L0882            ;0E0A  CD 82 08
  XCHG                  ;0E0D  EB
  LXI  H,L0004          ;0E0E  21 04 00
  DAD  SP               ;0E11  39
  MOV  C,M              ;0E12  4E
  INX  H                ;0E13  23
  MOV  B,M              ;0E14  46
  XCHG                  ;0E15  EB
  RET                   ;0E16  C9

L0E17:
  DW   L0E28            ;0E17  28 0E
  DB   'J'              ;0E19  4A  J
  DB   81H              ;0E1A  81  -
;-  (CFA - Code Field Area)
  CALL L0882            ;0E1B  CD 82 08
  XCHG                  ;0E1E  EB
  LXI  H,L000A          ;0E1F  21 0A 00
  DAD  SP               ;0E22  39
  MOV  C,M              ;0E23  4E
  INX  H                ;0E24  23
  MOV  B,M              ;0E25  46
  XCHG                  ;0E26  EB
  RET                   ;0E27  C9

L0E28:
  DW   L0E7B            ;0E28  7B 0E
  DB   'CREAT'          ;0E2A  43  C
                        ;0E2B  52  R
                        ;0E2C  45  E
                        ;0E2D  41  A
                        ;0E2E  54  T
  DB   85H              ;0E2F  85  -
;-  (CFA - Code Field Area)
L0E30:
  CALL L0E4D            ;0E30  CD 4D 0E
  CALL L0B78            ;0E33  CD 78 0B
  PUSH H                ;0E36  E5
  LXI  H,L0007          ;0E37  21 07 00
  DAD  B                ;0E3A  09
  XTHL                  ;0E3B  E3
  POP  B                ;0E3C  C1
  CALL L0B3C            ;0E3D  CD 3C 0B
L0E40:
  PUSH H                ;0E40  E5
  LHLD L1048            ;0E41  2A 48 10
  MVI  M,0C9H           ;0E44  36 C9
  INX  H                ;0E46  23  #
  SHLD L1048            ;0E47  22 48 10
  JMP  L0B20            ;0E4A  C3 20 0B
L0E4D:
  CALL L0999            ;0E4D  CD 99 09
  CALL L0882            ;0E50  CD 82 08
  PUSH H                ;0E53  E5
  LHLD L1048            ;0E54  2A 48 10
  SHLD L1046            ;0E57  22 46 10
  MVI  M,0FFH           ;0E5A  36 FF
  INX  H                ;0E5C  23
  MVI  M,0FFH           ;0E5D  36 FF
  INX  H                ;0E5F  23
  MVI  C,20H            ;0E60  0E 20
L0E62:
  MVI  B,7FH            ;0E62  06 7F
L0E64:
  LDAX D                ;0E64  1A
  MOV  M,A              ;0E65  77
  INX  H                ;0E66  23
  INX  D                ;0E67  13
  INR  B                ;0E68  04
  CMP  C                ;0E69  B9
  JNZ  L0E64            ;0E6A  C2 64 0E
  SHLD L1048            ;0E6D  22 48 10
  DCX  H                ;0E70  2B
  MOV  M,B              ;0E71  70
  XCHG                  ;0E72  EB
  SHLD L104C            ;0E73  22 4C 10
  POP  H                ;0E76  E1
  CALL L0856            ;0E77  CD 56 08
  RET                   ;0E7A  C9

L0E7B:
  DW   L0E85            ;0E7B  85 0E
  DB   5DH              ;0E7D  5D  ]
  DB   0C1H             ;0E7E  C1 - IMMEDIAT,
;-  (CFA - Code Field Area)
L0E7F:
  MVI  A,0FFH           ;0E7F  3E FF
  STA  L104B            ;0E81  32 4B 10
  RET                   ;0E84  C9

L0E85:
  DW   L0E8E            ;0E85  8E 0E
  DB   5BH              ;0E87  5B
  DB   0C1H             ;0E88  C1 - IMMEDIAT,
;-  (CFA - Code Field Area)
L0E89:
  XRA  A                ;0E89  AF
  STA  L104B            ;0E8A  32 4B 10
  RET                   ;0E8D  C9

L0E8E:
  DW   L0EA1            ;0E8E  A1 0E
  DB   22H              ;0E90  22
  DB   81H              ;0E91  81 -
;-  (CFA - Code Field Area)
L0E92:
  CALL L0999            ;0E92  CD 99 09
  CALL L0882            ;0E95  CD 82 08
  PUSH H                ;0E98  E5
  LHLD L1048            ;0E99  2A 48 10
  MVI  C,22H            ;0E9C  0E 22
  JMP  L0E62            ;0E9E  C3 62 0E

L0EA1:
  DW   L0EB6            ;0EA1  B6 0E
  DB   'ALLOT'          ;0EA3  41  A
                        ;0EA4  4C  L
                        ;0EA5  4C  L
                        ;0EA6  4F  O
                        ;0EA7  54  T
  DB   85H              ;0EA8  85   -
;-  (CFA - Code Field Area)
L0EA9:
  PUSH H                ;0EA9  E5
  LHLD L1048            ;0EAA  2A 48 10
  DAD  B                ;0EAD  09
  SHLD L1048            ;0EAE  22 48 10
  POP  H                ;0EB1  E1
  CALL L0856            ;0EB2  CD 56 08
  RET                   ;0EB5  C9

L0EB6:
  DW   L0EC9            ;0EB6  C9 0E
  DB   3AH              ;0EB8  3A  _:_
  DB   0C1H             ;0EB9  C1 - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0E30            ;0EBA  CD 30 0E
  CALL L0882            ;0EBD  CD 82 08
  LXI  B,LFFF9          ;0EC0  01 F9 FF
  CALL L0EA9            ;0EC3  CD A9 0E
  JMP  L0E7F            ;0EC6  C3 7F 0E

L0EC9:
  DW   L0ED3            ;0EC9  D3 0E
  DB   3BH              ;0ECB  3B _;_
  DB   0C1H             ;0ECC  C1 - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0E40            ;0ECD  CD 40 0E
  JMP  L0E89            ;0ED0  C3 89 0E

L0ED3:
  DW   L0EE4            ;0ED3  E4 0E
  DB   '.'              ;0ED6  2E  .
  DB   22H              ;0ED6  22 _"_
  DB   0C2H             ;0ED7  C2  - IMMEDIAT,
;-  (CFA - Code Field Area)
  CALL L0882            ;0ED8  CD 82 08
  LXI  B,L0A06          ;0EDB  01 06 0A
  CALL L0B29            ;0EDE  CD 29 0B
  JMP  L0E92            ;0EE1  C3 92 0E

L0EE4:
  DW   L0F99            ;0EE4  99 0F
  DB   '*/MOD'          ;0EE6  2A *
                        ;0EE7  2F /
                        ;0EE8  4D M
                        ;0EE9  4F O
                        ;0EEA  44 D
  DB   85H              ;0EEB  85 -
;-  (CFA - Code Field Area)
  XRA  A                ;0EEC  AF
  MVI  A,03H            ;0EED  3E 03
L0EEF:
  PUSH PSW              ;0EEF  F5
  MOV  A,B              ;0EF0  78
  ORA  A                ;0EF1  B7
  JP   L0EFB            ;0EF2  F2 FB 0E
  CALL L0B8B            ;0EF5  CD 8B 0B
  POP  PSW              ;0EF8  F1
  CMC                   ;0EF9  3F
  PUSH PSW              ;0EFA  F5
L0EFB:
  CALL L088D            ;0EFB  CD 8D 08
  POP  PSW              ;0EFE  F1
  DCR  A                ;0EFF  3D  =
  JNZ  L0EEF            ;0F00  C2 EF 0E
  PUSH PSW              ;0F03  F5
  CALL L0F16            ;0F04  CD 16 0F
  POP  PSW              ;0F07  F1
  RNC                   ;0F08  D0
  CALL L0B8B            ;0F09  CD 8B 0B
  CALL L08CE            ;0F0C  CD CE 08
  CALL L0B8B            ;0F0F  CD 8B 0B
  CALL L08CE            ;0F12  CD CE 08
  RET                   ;0F15  C9

L0F16:
  PUSH B                ;0F16  C5
  CALL L0856            ;0F17  CD 56 08
  MOV  E,M              ;0F1A  5E
  INX  H                ;0F1B  23
  MOV  D,M              ;0F1C  56
  PUSH H                ;0F1D  E5
  LXI  H,L0000          ;0F1E  21 00 00
  PUSH H                ;0F21  E5
  MVI  A,10H            ;0F22  3E 10
L0F24:
  STA  L107E            ;0F24  32 7E 10
  DAD  H                ;0F27  29
  XTHL                  ;0F28  E3
  CC   L0F54            ;0F29  DC 54 0F
  CNC  L0F52            ;0F2C  D4 52 0F
  XTHL                  ;0F2F  E3
  CALL L0C5E            ;0F30  CD 5E 0C
  JNC  L0F3D            ;0F33  D2 3D 0F
  DAD  D                ;0F36  19
  JNC  L0F3D            ;0F37  D2 3D 0F
  XTHL                  ;0F3A  E3
  INX  H                ;0F3B  23
  XTHL                  ;0F3C  E3
L0F3D:
  LDA  L107E            ;0F3D  3A 7E 10
  DCR  A                ;0F40  3D
  JNZ  L0F24            ;0F41  C2 24 0F
  POP  B                ;0F44  C1
  XCHG                  ;0F45  EB
  POP  H                ;0F46  E1
  MOV  M,D              ;0F47  72
  DCX  H                ;0F48  2B
  MOV  M,E              ;0F49  73
  NOP                   ;0F4A  00
  CALL L0882            ;0F4B  CD 82 08
  POP  B                ;0F4E  C1
  JMP  L0F5E            ;0F4F  C3 5E 0F

L0F52:
  DAD  H                ;0F52  29
  RET                   ;0F53  C9

L0F54:
  DAD  H                ;0F54  29
  INX  H                ;0F55  23
  STC                   ;0F56  37
  RET                   ;0F57  C9

L0F58:
  LXI  D,L0000          ;0F58  11 00 00
  JMP  L0F62            ;0F5B  C3 62 0F

L0F5E:
  MOV  E,M              ;0F5E  5E
  INX  H                ;0F5F  23
  MOV  D,M              ;0F60  56
  INX  H                ;0F61  23
L0F62:
  PUSH D                ;0F62  D5
  MOV  E,M              ;0F63  5E
  INX  H                ;0F64  23
  MOV  D,M              ;0F65  56
  INX  H                ;0F66  23
  XTHL                  ;0F67  E3
  MOV  A,L              ;0F68  7D
  SUB  C                ;0F69  91
  MOV  A,H              ;0F6A  7C
  SBB  B                ;0F6B  98
  JNC  L0860            ;0F6C  D2 60 08
  XRA  A                ;0F6F  AF
L0F70:
  DAD  H                ;0F70  29
  PUSH PSW              ;0F71  F5
  XCHG                  ;0F72  EB
  DAD  H                ;0F73  29
  XCHG                  ;0F74  EB
  JNC  L0F79            ;0F75  D2 79 0F
  INX  H                ;0F78  23
L0F79:
  MOV  A,L              ;0F79  7D
  SUB  C                ;0F7A  91
  MOV  L,A              ;0F7B  6F
  MOV  A,H              ;0F7C  7C
  SBB  B                ;0F7D  98
  MOV  H,A              ;0F7E  67
  JC   L0F87            ;0F7F  DA 87 0F
  POP  PSW              ;0F82  F1
L0F83:
  INX  D                ;0F83  13
  JMP  L0F8C            ;0F84  C3 8C 0F

L0F87:
  POP  PSW              ;0F87  F1
  JC   L0F83            ;0F88  DA 83 0F
  DAD  B                ;0F8B  09
L0F8C:
  ADI  10H              ;0F8C  C6 10
  JNC  L0F70            ;0F8E  D2 70 0F
  MOV  B,D              ;0F91  42
  MOV  C,E              ;0F92  4B
  XTHL                  ;0F93  E3
  CALL L0882            ;0F94  CD 82 08
  POP  B                ;0F97  C1
  RET                   ;0F98  C9

L0F99:
  DW   L0FA5            ;0F99  A5 0F
  DB   'HEX'            ;0F9B  48  H
                        ;0F9C  45  E
                        ;0F9D  58  X
  DB   83H              ;0F9E  83  -
;-  (CFA - Code Field Area)
  MVI  A,10H            ;0F9F  3E 10
  STA  L104A            ;0FA1  32 4A 10
  RET                   ;0FA4  C9

L0FA5:
  DW   L0FB5            ;0FA5  B5
  DB   'DECIMAL'        ;0FA6  0F
                        ;0FA7  44  D
                        ;0FA8  45  E
                        ;0FA9  43  C
                        ;0FAA  49  I
                        ;0FAB  4D  M
                        ;0FAC  41  A
                        ;0FAD  4C  L
  DB   87H              ;0FAE  87  -
;-  (CFA - Code Field Area)
  MVI  A,0AH            ;0FAF  3E 0A
  STA  L104A            ;0FB1  32 4A 10
  RET                   ;0FB4  C9

L0FB5:
  DW   L1100            ;0FB5  00 11
  DB   2EH              ;0FB7  2E _._
  DB   81H              ;0FB8  81 -
;-  (CFA - Code Field Area)
  MOV  A,B              ;0FB9  78
  ORA  A                ;0FBA  B7
  CM   L0FF7            ;0FBB  FC F7 0F
  PUSH H                ;0FBE  E5
  LXI  H,L1057          ;0FBF  21 57 10
  MVI  M,0FFH           ;0FC2  36 FF
  DCX  H                ;0FC4  2B
  MVI  M,20H            ;0FC5  36 20
  XTHL                  ;0FC7  E3
L0FC8:
  CALL L0882            ;0FC8  CD 82 08
  LXI  B,L0000          ;0FCB  01 00 00
  LDA  L104A            ;0FCE  3A 4A 10
  MOV  C,A              ;0FD1  4F  O
  CALL L0F58            ;0FD2  CD 58 0F
  MOV  A,C              ;0FD5  79  y
  CALL L0856            ;0FD6  CD 56 08
  ORI  30H              ;0FD9  F6 30
  CPI  3AH              ;0FDB  FE 3A _:_>9
  JM   L0FE2            ;0FDD  FA E2 0F
  ADI  07H              ;0FE0  C6 07
L0FE2:
  XTHL                  ;0FE2  E3
  DCX  H                ;0FE3  2B
  MOV  M,A              ;0FE4  77
  XTHL                  ;0FE5  E3
  XRA  A                ;0FE6  AF
  CMP  C                ;0FE7  B9
  JNZ  L0FC8            ;0FE8  C2 C8 0F
  CMP  B                ;0FEB  B8
  JNZ  L0FC8            ;0FEC  C2 C8 0F
  POP  B                ;0FEF  C1
  CALL L09F5            ;0FF0  CD F5 09
  CALL L0856            ;0FF3  CD 56 08
  RET                   ;0FF6  C9

L0FF7:
  CALL L0A06            ;0FF7  CD 06 0A
  DB   2DH              ;0FFA  2D
  DB   0FFH             ;0FFB  FF
  CALL L0B8B            ;0FFC  CD 8B 0B
  RET                   ;0FFF  C9

L0000:   EQU  0000H
L0002:   EQU  0002H
L0004:   EQU  0004H
L0007:   EQU  0007H
L000A:   EQU  000AH

L1040:   EQU  1040H;     JMP 0F803H
L1043:   EQU  1043H;     JMP 0F809H
L1046:   EQU  1046H;           
L1048:   EQU  1048H;         
L104A:   EQU  104AH;        
L104B:   EQU  104BH
L104C:   EQU  104CH
L104E:   EQU  104EH
L1057:   EQU  1057H
L107E:   EQU  107EH
L1080:   EQU  1080H

L1100:   EQU  1100H;        

L2100:   EQU  2100H;     Text Buffer
L2E0E:   EQU  2E0EH
L410C:   EQU  410CH
L4D2F:   EQU  4D2FH
L510A:   EQU  510AH
L540A:   EQU  540AH
L7E81:   EQU  7E81H
L7E82:   EQU  7E82H
L812E:   EQU  812EH
L822A:   EQU  822AH
L822F:   EQU  822FH
L82CD:   EQU  82CDH
LCDC2:   EQU  0CDC2H

LF800:   EQU  0F800H
LF803:   EQU  0F803H
LF809:   EQU  0F809H

LFFF9:   EQU  0FFF9H
LFFFF:   EQU  0FFFFH
  END

